$.extend(FS.Trans, {
	getAllSimpleProcess : function() {
		return this.ajax({
			url : FR.servletURL + "?op=process_ob&cmd=allsimple"
		});
	}
});

/** b:飬Ӻ
 * 
 */
FS.Auth = FS.extend(FS.Widget, {
		init : function(config) {
			this.element = $('<div/>').attr('id', 'fs_auth');
			this.barInit();
			this.usersPaneInit();
			this.element.append(this.toolbar).append(this.usersPane);
			this.setType(config.controlType);
			this.resize(config);
		},
		
		setType : function (type) {
			this.controlType = type;
			if (type === 1) {
				$('.fs_auth_control_bar', this.element).hide();
			} else {
				$('.fs_auth_control_bar', this.element).show();
			}
		},
		
		barInit : function() {
			this.toolbar = $('<div/>').attr('id', 'fs_authtoolbar');
			var self = this;
			this.userb = new FS.ToolbarButton({
				text : 'û',
				height : 24,
				width : 76,
				handler : function() {
					self.orgnizeb.element.removeClass('fs_button_selected');
					self.roleb.element.removeClass('fs_button_selected');
					if (self.orgnizePane) {
						self.orgnizePane.hide();
					}
					if (self.rolePane) {
						self.rolePane.hide();
					}
					self.setType(self.controlType);
					self.usersPane.show();				
				}
			});
			this.userb.element.addClass('fs_button_selected');
			this.orgnizeb = new FS.ToolbarButton({
				text : '',
				height : 24,
				width : 76,
				handler : function() {
					self.userb.element.removeClass('fs_button_selected');
					self.roleb.element.removeClass('fs_button_selected');
					self.usersPane.hide();
					if (self.rolePane) {
						self.rolePane.hide();
					}
					if (!self.orgnizePane) {
						self.orgnizePaneInit();
					}
					self.setType(self.controlType);
					self.orgnizePane.show();
				}
			});
			this.roleb = new FS.ToolbarButton({
				text : 'Ȩ޹',
				height : 24,
				width : 76,
				handler : function() {
					self.userb.element.removeClass('fs_button_selected');
					self.orgnizeb.element.removeClass('fs_button_selected');
					self.usersPane.hide();
					if (self.orgnizePane) {
						self.orgnizePane.hide();
					}
					if (!self.rolePane) {
						self.rolePaneInit();
					}
					self.setType(self.controlType);
					self.rolePane.show();
				}
			});
			this.toolbar.append(this.userb.element.addClass('fs_usersbutton')).append(this.orgnizeb.element.addClass('fs_orgnizebutton'))
				.append(this.roleb.element.addClass('fs_rolebutton'));
		},
		
		usersPaneInit : function() {
			this.usersPane = $('<div/>').attr('id', 'fs_auth_usersPane');
			var bar = $('<div/>').attr('id', 'fs_auth_users_opbar').css('position', 'relative').addClass('fs_auth_control_bar');
			var usersTable;
			var addUser = new FS.Button({
				text : 'û',
				handler : function() {
					usersTable.uiAddData();
				}
			}), editUser = new FS.Button({
				text : '༭û',
				disabled : true,
				handler : function() {
					usersTable.uiEditData();
				}
			}), removeUser = new FS.Button({
				text : 'Ƴû',
				disabled : true,
				handler : function() {
					usersTable.uiRemoveData();
				}
			});
			bar.append(addUser.element.addClass('fs_auth_adduser')).append(editUser.element.addClass('fs_auth_edituser')).append(removeUser.element.addClass('fs_auth_removeuser'));
			
			usersTable = new FS.Grid({
				cls : 'fs_auth_userstable',
				height : 400,
				selfbar : bar,
				pagecount : 15,
				columnsconfig : [{
					text : 'username',
					showValue : 'û',
					width : 200,
					sort : false,
					widget : {type : 'text', allowBlank : false, errorMsg :  'ûΪգ'}
				}, {
					text : 'realname',
					showValue : '',
					width : 200,
					widget : {type : 'text', allowBlank : false, errorMsg :  'Ϊգ'}
				}, {
					text : 'password',
					showValue : '',
					width : 200,
					widget : {type : 'text', passwordText : true, allowBlank : false, errorMsg :  '벻Ϊգ'}
				}, {
					text : 'depart',
					showValue : 'ְ',
					width : 180
				}],
				items : []
			});
			usersTable.loading(true);
			usersTable.on(FS.Events.SELECTDATA, function() {
				editUser.setEnable(true);
				removeUser.setEnable(true);
			});
			
			usersTable.on(FS.Events.NOSELECT, function() {
				editUser.setEnable(false);
				removeUser.setEnable(false);
			});
			
			usersTable.on(FS.Events.APPENDDATA, function(item) {
				var id = FS.Trans.addUser(item);
				if (!/^\d+$/.test(id)) {
					FR.Msg.toast("ûʧܣû");
					return false;
				}
				item.id = id;
			});
			
			usersTable.on(FS.Events.EDITDATA, function(item) {
				FS.Trans.addUser(item);
			});
			
			usersTable.on(FS.Events.REMOVEDATA, function(item) {
				FS.Trans.removeUser(item.id);
			});
			setTimeout(function() {
				usersTable.popData(FS.Trans.getAllUsers());
			}, 100);
			this.usersPane.append(usersTable.element);
		},
		
		orgnizePaneInit : function() {
			if (this.orgnizePane) {
				return;
			}
			var authorgnize = new FS.AuthOrgnize();
			this.orgnizePane = authorgnize.element;
			this.element.append(this.orgnizePane);
			this.orgnizePane.width(this.element.width()).height(this.element.height() - 52);
			//daniel ѡroot
			authorgnize.department.selecteByID('-1');
		},
		
		rolePaneInit : function() {
			if (this.rolePane) {
				return;
			}
			this.authRole = new FS.AuthRole();
			this.rolePane = this.authRole.element;
			this.element.append(this.rolePane);
			this.rolePane.width(this.element.width()).height(this.element.height() - 52);
		},
		
		refreshWidgets : function() {
			if (this.authRole && this.authRole.reportWidgetList) {
				this.authRole.refreshWidgetList();
			}			
		},
		
		refreshProcess : function() {
			if (this.authRole && this.authRole.processList) {
				this.authRole.refreshProcessList();
			}			
		},
		
		resize : function(rec) {
				if (!rec) {
		 			var p = this.element.parent();
		 			rec = {
		 				width : p.width(),
		 				height : p.height()
		 			};
		 		}
				this.element.width(rec.width).height(rec.height);
				this.toolbar.width(rec.width).height(52);
				this.usersPane.width(rec.width).height(rec.height - 52);
				if (this.orgnizePane) {
					this.orgnizePane.width(rec.width).height(rec.height - 52);
				}
			if (this.rolePane) {
				this.rolePane.width(rec.width).height(rec.height - 52);
			}
		}
	});
	
FS.AuthOrgnize = FS.extend(FS.Widget, {
	init : function(config) {
			this.element = $('<div/>').attr('id', 'fs_auth_orgnize');
			this.createOfficeTree();
			this.createPositionList();
			this.element.append(this.department.element).append(this.employee.element);
	},
	
	createOfficeTree : function() {
			var officebar = $('<div/>').attr('id', 'fs_auth_officebar').addClass('fs_auth_control_bar');

			var self = this;
			var addoffice = new FR.IconButton({
 				title : 'Ӳ',
 				height : 21,
				width : 21,
 				renderEl : $('<span>&nbsp;</span>').appendTo(officebar),
 				baseClass : 'fr_auth_addoffice',
 				handler : function() {
 					self.officeDialogShow();
 				},
 				disabled : true
 			}), editoffice = new FR.IconButton({
 				title : '༭',
 				height : 21,
				width : 21,
 				renderEl : $('<span>&nbsp;</span>').appendTo(officebar),
 				baseClass : 'fr_auth_editoffice',
 				handler : function() {
 					self.officeDialogShow(self.department.getSelectedName());
 				},
 				disabled : true
 			}), removeoffice = new FR.IconButton({
 				title : 'ɾ',
 				height : 21,
				width : 21,
 				renderEl : $('<span>&nbsp;</span>').appendTo(officebar),
 				baseClass : 'fr_auth_removeoffice',
 				handler : function() {
 					FS.showConfirmDialog({
 						callback : function() {
 							self.department.removeSelectedData();
 							self.department.reBuild(FS.Trans.getAllDepart());
 						}
 					});	
 				},
 				disabled : true
 			});
 			
			this.department = new FS.BarTree({
				title : 'Ź:',
				barcontent : officebar,
				treedata : FS.Trans.getAllDepart(),
				folderMode : true,
				width : 200,
				height : 450
			});
			var self = this;
			this.department.on(FR.Events.CLICK, function() {			
				addoffice.setEnable(true);
				if (parseInt(this.getSelectedData().getID()) < 0) {
					editoffice.setEnable(false);
					removeoffice.setEnable(false);
					self.addposition.setEnable(false);
				} else {
					editoffice.setEnable(true);
					removeoffice.setEnable(true);
					self.addposition.setEnable(true);
				}

				var es = FS.Trans.getAllEmployee(this.getSelectedData().getID()), ec = [];
				for (var i = 0, len = es.length; i < len; i++) {
					var em = es[i].username + "(" + es[i].postname + ")";
					es[i].text = es[i].value = em;
					ec.push(es[i]);
				}
				self.employee.popData(ec);
			});
			this.department.on(FS.Events.NOSELECT, function() {
				self.addposition.setEnable(false);
				addoffice.setEnable(false);
				editoffice.setEnable(false);
				removeoffice.setEnable(false);
				self.employee.list.setEnable(false);
			});
			this.department.on(FS.Events.EDITDATA, function(node) {
				FS.Trans.addDepart(node);
			});
			this.department.on(FS.Events.REMOVEDATA, function(node) {
				FS.Trans.removeDepart(node.getID());
			});
	},
	
	_getDataNameList : function (nameList, data) {
		var self = this;
		if (data) {
			$.each(data, function(idx, item){
				nameList.push(item.getValue());
				self._getDataNameList(nameList, item.getChildren());
			})
		}
	},
	
	officeDialogShow : function (name) {
		this.showName = name;
		var self = this;	
		var nameList = [];
		var data = self.department.getAllData();
		self._getDataNameList(nameList, data);		
		FS.showPromoteDialog({
			title : name == null ? 'Ӳ' : '޸Ĳ',
			message : ':',
			value : name,
			checkRepeat : true,
			nameList : nameList,
			waringText : 'Ѵڸòţ',
			opt : {
				allowBlank : false
			},
			checkRule : false,
		 	callback : function(value) {
		 		if (self.showName == null) {
					var depart = FS.Trans.addDepart({parentID : self.department.tree.getSelectedData().getID(), text : value});
					if (depart) {
						self.department.addData(depart);
						self.department.reBuild(FS.Trans.getAllDepart());
					}				
				} else {
					self.department.reName(value);
				}
		 	}
		});	
	},
	
	createPositionList : function() {
			var positionbar = $('<div/>').attr('id', 'fs_auth_officebar').addClass('fs_auth_control_bar');

			var self = this;
			this.addposition = new FR.IconButton({
 				title : 'Ա',
 				height : 21,
				width : 21,
 				renderEl : $('<span>&nbsp;</span>').appendTo(positionbar),
 				baseClass : 'fr_auth_addposition',
 				disabled : true,
 				handler : function() {
 					self.positionDialogShow();
 				}
 			});
 			var editposition = new FR.IconButton({
 				title : '༭Ա',
 				height : 21,
				width : 21,
 				renderEl : $('<span>&nbsp;</span>').appendTo(positionbar),
 				baseClass : 'fr_auth_editposition',
 				handler : function() {
 					self.positionDialogShow(self.employee.getSelectedData());
 				},
 				disabled : true
 			}), removeposition = new FR.IconButton({
 				title : 'ɾԱ',
 				height : 21,
				width : 21,
 				renderEl : $('<span>&nbsp;</span>').appendTo(positionbar),
 				baseClass : 'fr_auth_removeposition',
 				handler : function() {
 					FS.showConfirmDialog({
 						callback : function() {
 							self.employee.removeSelectedData();
 						}
 					});					
 				},
 				disabled : true
 			});

			this.employee = new FS.BarList({
				title : 'Ա:',
				barcontent : positionbar,
				items : [],
				width : 200,
				height : 450
			});
			this.employee.on(FR.Events.CLICK, function() {
				editposition.setEnable(true);
				removeposition.setEnable(true);
			});
			this.employee.on(FR.Events.NOSELECT, function() {
				editposition.setEnable(false);
				removeposition.setEnable(false);				
			});
			this.employee.on(FR.Events.APPENDDATA, function(employee) {
				employee.id = FS.Trans.addEmployee(employee);
				employee.text = employee.value = employee.username + "(" + employee.postname + ")";
			});
			this.employee.on(FR.Events.EDITDATA, function(employee) {
				FS.Trans.addEmployee(employee);
				employee.text = employee.value = employee.username + "(" + employee.postname + ")";
			});
			this.employee.on(FR.Events.REMOVEDATA, function(employee) {
				FS.Trans.removeEmployee(employee.getContent().id);
			});
	},
	
	positionDialogShow : function(employee){
		var positionDialog = this.positionDialog;
		var removePositionList, users, positionName, addButton;
		this.employeeName = employee;
		if (positionDialog) {
			positionDialog.setTitle(employee == null ? 'ְԱ' : '༭ְԱ');
			if (employee) {
				this.users.setValueByID(employee.userid);
				this.removePositionList.setValueByID(employee.postid);
			}
			positionDialog.setVisible(true);
			return;
		}
		var self = this;
		var content = $('<div/>').attr('id', 'fs_auth_position_content');
		var posts = FS.Trans.getAllPost(), choosePost = [];
		for (var i = 0, len = posts.length; i < len; i++) {
			var post = posts[i];
			choosePost.push({
				id : post.id,
				text : post.postname,
				value : post.postname
			});
		}
		this.removePositionList = removePositionList = new FS.RemoveList({
			width : 200,
			height : 250,
			items : choosePost,
			removeConfirm : function(callback) {
				FS.showConfirmDialog({
 						callback : callback
 				});					
			}
		});
		this.users = users = new FS.Combobox({
			width : 120,
			height : 24,
			items : [],
			editable : true
		}); 
		this.positionName = positionName = new FS.TextEditor({
			width : 120,
			height : 24
		});
		var addButton = new FS.Button({
			text : '',
			width : 60,
			height : 20,
			handler : function() {
				var position = positionName.getValue(), list = removePositionList;
				if (list.getNames().indexOf(position) > -1) {
					return;
				}
				list.addName(position);
			}
		});
		users.on(FR.Events.CLICK,  function() {
			var users = FS.Trans.getNormalUsers(), chooseUsers = [];
			for (var i = 0, len = users.length; i < len; i++) {
				var user = users[i];
				chooseUsers.push({
					id : user.id,
					text : user.username,
					value : user.username
				});
			}
			this.reBuild(chooseUsers);
		});
		removePositionList.on(FR.Events.CLICK, function(index, record) {
			positionName.setValue(record.getValue());
		});
		removePositionList.on(FS.Events.APPENDDATA, function(data) {
			data.id = FS.Trans.addPost({postname : data.text});
		});
		removePositionList.on(FS.Events.REMOVEDATA, function(position) {
			FS.Trans.removePost(position.getContent().id);
		});
		content.append($('<table/>').attr({'cellSpacing' : 8}).append($('<tbody/>')
			.append($('<tr/>').height(24).append($('<td/>').text('û:')).append($('<td/>').append(users.element)).append($('<td/>')))
			.append($('<tr/>').height(24).append($('<td/>').text('ְ:')).append($('<td/>').append(positionName.element)).append($('<td/>').append(addButton.element)))));
		content.append(removePositionList.element.addClass('fs_auth_positionlist'));	

		var confire = function() {
			var userid = users.getSelectedID();
			if (userid == null) {
				FR.Msg.toast('ѡû.');
				return false;
			}
			var post = removePositionList.getSelectedData();
			if (post == null) {
				FR.Msg.toast('ѡְλ.');
				return false;
			}
			var em = {
				departid : self.department.getSelectedData().getID(),
				userid : userid,
				postid : post.id,
				username : users.getValue(),
				postname : removePositionList.getValue()
			};
			if (self.employeeName) {
				self.employee.reData(em);
			} else {
				self.employee.addData(em);
			}
			
		};
		this.positionDialog = new FS.Dialog({
			title : 'Ա',
		 	width:340,
		 	height : 420,
		 	confire : confire,
		 	content : content
		});
		if (employee) {
			this.users.setValueByID(employee.userid);
			this.removePositionList.setValueByID(employee.postid);
		}
	}
});

FS.AuthRole = FS.extend(FS.Widget, {
	init : function(config) {
		this.element = $('<div/>').attr('id', 'fs_auth_role');
		this.createRoleList();
		this.createToolBarPane();
		this.createOrgnizeRolePane();
		this.createCustomRolePane();
		this.createReportTreePane();
		this.createProcessList();
		this.createModuleManageTree();
		//this.createSubmitButton();
		this.generatePrevent();
	},
	
	generatePrevent : function() {
		this.prevent = $('<div/>').addClass('fr-window-mask').css({position : 'absolute', left : 180, top : 30, width : 720, height : 480});
		this.element.append(this.prevent);
	},
	
	setEnable : function(enable) {
		if (enable) {
			this.prevent.hide();
		} else {
			this.prevent.show();
		}
	},
	
	createRoleList : function() {
			var rolebar = $('<div/>').attr('id', 'fs_auth_rolebar');
			var self = this;
			var addDepartment = new FR.IconButton({
 				title : 'ӲŽɫ',
 				height : 21,
				width : 21,
 				renderEl : $('<span>&nbsp;</span>').appendTo(rolebar),
 				baseClass : 'fs_auth_addorgnizerole',
 				handler : function() {
 					self.addDepartmentRole();
 				}
 			}), editrole = new FR.IconButton({
 				title : 'Զɫ',
 				height : 21,
				width : 21,
 				renderEl : $('<span>&nbsp;</span>').appendTo(rolebar),
 				baseClass : 'fs_auth_addcustomrole',
 				handler : function() {
 					self.addCustomRole();
 				}
 			}), removerole = new FR.IconButton({
 				title : 'ɾɫ',
 				height : 21,
				width : 21,
 				renderEl : $('<span>&nbsp;</span>').appendTo(rolebar),
 				baseClass : 'fs_auth_removerole',
 				handler : function() {
 					self.roleList.removeSelectedData();
 				},
 				disabled : true
 			});
 			var roles = FS.Trans.getRoles();
 			for (var i = 0, len = roles.length; i < len; i++) {
 				if (roles[i].departmentname != null) {
 					roles[i].text = roles[i].departmentname + roles[i].postname;
 				}				
 			}
			this.roleList = new FS.BarList({
				barcontent : rolebar,
				items : roles,
				width : 160,
				height : 500 
			});
			this.roleList.element.addClass('fs_auth_rolelist');
			this.roleList.on(FR.Events.CLICK, function() {
				removerole.setEnable(true);
				self.setEnable(true);
				self.popRole(this.getSelectedData());
			});
			this.roleList.on(FS.Events.NOSELECT, function() {
				removerole.setEnable(false);
				self.setEnable(false);			
			});
			
			this.roleList.on(FR.Events.REMOVEDATA, function(role) {
				self.clearState();
				var id = role.getContent().id;
				if (id != null && id > -1) {
					FS.Trans.removeRole(role.getContent());
				}
			});
			/*b:лύlater*/
			this.roleList.on(FR.Events.BEFORESTATECHANGE, function () {
//				self.saveRole();
			});
			this.element.append(this.roleList.element);
	},
	
	createToolBarPane : function() {
		this.toolbarPane = $('<div/>').attr('id', 'fs_auth_toolbar').width(620).height(24).appendTo(this.element);
	},

	createOrgnizeRolePane : function() {
		this.orgnizeRolePane = $('<div/>').attr('id', 'fs_auth_roleorgnize').width(620).height(160).appendTo(this.element);
		
		this.orgnizeCombo = new FS.TreeCombo({
			width : 120,
			height : 20,
			disableID : -1,
			editable : false
		});
		this.orgnizeCombo.on(FR.Events.CLICK,  function() {
			var data = new FR.SynchronTreeData({
        		dataSource : new FR.SynchronTreeSource({
        			treedata : FS.Trans.getSpecialDepart()
        		})
        	});
			this.reBuild(data);
		});
		
		this.positionCombo = new FS.Combobox({
			width : 120,
			height : 20,
			items : []
		});
		this.positionCombo.on(FR.Events.CLICK,  function() {
			var posts = FS.Trans.getSpecialPost(), choosePost = [];
			for (var i = 0, len = posts.length; i < len; i++) {
				var post = posts[i];
				choosePost.push({
					id : post.id,
					text : post.postname,
					value : post.postname
				});
			}
			this.reBuild(choosePost);
		});
		var self = this;
		this.orgnizeCombo.on(FR.Events.AFTEREDIT, function() {
			var orgValue = this.getValue();
			if (orgValue[0] == "root") {
				orgValue.shift();
			}
			var posValue = self.positionCombo.getValue()
			self.roleList.reName(orgValue + posValue);
			if (orgValue.length > 0 && posValue !== "") {
				self.autoRoleSave();
			}
		});
		this.positionCombo.on(FR.Events.AFTEREDIT, function(){
			var orgValue = self.orgnizeCombo.getValue();
			if (orgValue[0] == "root") {
				orgValue.shift();
			}
			var posValue = this.getValue();
			self.roleList.reName(orgValue + posValue);
			if (orgValue.length > 0 && posValue !== "") {
				self.autoRoleSave();
			}
		});
		$('<table/>').attr({id: 'fs_auth_roleorgnizetable', cellPadding : 8}).append($('<tbody/>')
			.append($('<tr/>').append($('<td/>').attr('colSpan', 4).text('Žɫ:')))
			.append($('<tr/>').append($('<td/>').text(':')).append($('<td/>').append(this.orgnizeCombo.element)).append($('<td/>').text('ְ:')).append($('<td/>').append(this.positionCombo.element)))).appendTo(this.orgnizeRolePane);
	},
	
	createCustomRolePane : function() {
		this.customRolePane = $('<div/>').attr('id', 'fs_auth_rolecustom').width(620).height(160).hide().appendTo(this.element);
		this.nameText = new FS.TextEditor({
			width : 120,
			height : 20
		});
		this.nameText.on(FR.Events.AFTEREDIT, function(){
			self.roleList.reName(this.getValue());
			self.autoRoleSave();
		});
		var self = this;
		var addRoleButton = new FS.Button({
			text : 'û',
			height : 20,
			handler : function() {
				self.usersChooseDialogShow(self.usersPane.getUsers());
			}
		});
		$('<table/>').attr({id: 'fs_auth_rolecustomtable', cellPadding : 4}).append($('<tbody/>')
			.append($('<tr/>').append($('<td/>').attr('colSpan', 2).text('Զɫ:')))
			.append($('<tr/>').append($('<td/>').text('ɫ:')).append($('<td/>').append(this.nameText.element)))
			.append($('<tr/>').append($('<td/>').text('ӽɫ:')).append($('<td/>').append(addRoleButton.element)))).appendTo(this.customRolePane);
		this.usersPane = new FS.ButtonsTable({
			width : 320,
			height : 120,
			container : this
		});
		this.customRolePane.append(this.usersPane.element);
	},
	
	removeSelf : function(user) {
		FS.Trans.removeRoleUser(this.roleList.getSelectedData().id, user.id);
	},
	
	usersChooseDialogShow : function(users) {
		var usersDialog = this.usersDialog;
		this.users = users;
		if (usersDialog) {
			this.usersWidget.refresh();
			if (users) {
				this.usersWidget.popUsers(users);
			}
			
			usersDialog.setVisible(true);
			return;
		}
		var self = this;
		var content = $('<div/>').attr('id', 'fs_auth_role_usercontent');
		this.usersWidget = new FS.usersWidget();
		content.append(this.usersWidget.element);
		var confire = function() {
			var users = self.usersWidget.getUsers();

			var id = self.roleList.getSelectedData().id;
			if (id > -1) {
				var uids = $.map(users, function(user) {
					return user.id;
				});
				FS.Trans.addRoleUsers(self.roleList.getSelectedData().id, uids);
			}
			
			self.usersPane.popUsers(users);		
			self.autoRoleSave();	
		};
		if (users) {
			this.usersWidget.popUsers(users);
		}
		this.usersDialog = new FS.Dialog({
			title : 'ӲԱ',
		 	width:420,
		 	height : 360,
		 	confire : confire,
		 	content : content
		});	
	},
	
	createReportTreePane : function() {
		try {
			this.reportTree = new FS.Tree({
				width : 200,
				height : 300,
				showcheck : true,
				f2scascade : true,
				s2fcascade : true,
				treedata : [],
				onnxodeclick : function(){
					self.autoRoleSave();
				}
			});
			var self = this;
			this.reportTree.on(FS.Events.RELOADDATA, function() {
				this.reBuild(FS.Trans.getAllReports());
				self.report_backup = null;
			});		
			setTimeout(function() {
				self.reportTree.fireEvent(FS.Events.RELOADDATA);
			}, 25);			
		} catch(e) {
			
		}
		
		this.reportTree.element.attr('id', 'fs_auth_role_reporttree').appendTo(this.element);
	},
	
	createProcessList : function() {
//		this.reportWidgetList = new FS.List({
//			width : 160,
//			height : 300,
//			multi : true,
//			items : []
//		});
//		var self = this;
//		this.reportWidgetList.on(FS.Events.RELOADDATA, function() {
//			this.reBuild(FS.Trans.getReportWidgets());
//			self.widget_backup = null;
//		});
//		setTimeout(function() {
//			self.reportWidgetList.fireEvent(FS.Events.RELOADDATA);
//		}, 25);	
//		this.reportWidgetList.element.attr('id', 'fs_auth_role_reportwidget').appendTo(this.element);
		this.processList = new FS.List({
			width : 160,
			height : 300,
			multi : true,
			items : []
		});
		var self = this;
		this.processList.on(FS.Events.RELOADDATA, function() {
			this.reBuild(FS.Trans.getAllSimpleProcess());
			self.widget_backup = null;
		});
		this.processList.on(FR.Events.CLICK, function() {
				self.autoRoleSave();
		});	
		setTimeout(function() {
			self.processList.fireEvent(FS.Events.RELOADDATA);
		}, 25);	
		this.processList.element.attr('id', 'fs_auth_role_reportwidget').appendTo(this.element);
	},
	
	createModuleManageTree : function() {
		try {
			this.moduleTree = new FS.Tree({
				simpleMode : true,
				width : 190,
				height : 300,
				showcheck : true,
				folderMode : true,				
				f2scascade : true,
				s2fcascade : true,
				treedata : [],
				onnxodeclick : function(){
					self.autoRoleSave();
				}
			});
			var self = this;
			this.moduleTree.on(FS.Events.RELOADDATA, function() {
				this.reBuild(FS.Trans.getAllModules());
				self.module_backup = null;
			});
			setTimeout(function() {
				self.moduleTree.fireEvent(FS.Events.RELOADDATA);
			}, 25);	
		} catch(e) {
			
		}
		this.moduleTree.element.attr('id', 'fs_auth_role_moduleTree').appendTo(this.element);
	},
//	
//	createSubmitButton : function() {
//		var self = this;
//		var sb = new FS.Button({
//			text : '',
//			handler : function() {
//				self.saveRole();
//			}
//		});
//		sb.element.addClass('fs_auth_role_savebutton').appendTo(this.element);
//	},
	
	popuData : function() {
		
	},
	
	addDepartmentRole : function() {
		this.roleList.addData({departmentid : -1, postid : -1, text : this.createUnRepeatName('ѡְ')});
		this.autoRoleSave();
	},
	
	addCustomRole : function() {
		this.roleList.addData({text : this.createUnRepeatName('ͨɫ')});
		this.autoRoleSave();
	},
	
	createUnRepeatName : function(name) {
		if (name == null) {
			name = "ͨɫ";
		}
		var allRoles = this.roleList.getAll();
		if(allRoles.length == 0) {
			return name + "1";
		}
		for(var i = 1; i < 10000; i ++) {
			var newName = name + i;
			for(var m = 0; m < allRoles.length; m ++) {
				if(allRoles[m].text == newName) {
					break ;
				}
				if(m == allRoles.length - 1) {
					return newName;
				}
			}
		}	
	},
	
	popRole : function(role) {
		if (!this.orgnizeCombo.options.data) {
			this.orgnizeCombo.fireEvent(FR.Events.CLICK);
		} 
		if (!this.positionCombo.options.data) {
			this.positionCombo.fireEvent(FR.Events.CLICK);
		}
		this.clearState();

		if (role.departmentid != null || role.postid != null) {
			this.orgnizeRolePane.show();
			this.customRolePane.hide();
			if (role.departmentid > -1) {
				this.orgnizeCombo.setValueByID(role.departmentid);
			}
			if (role.postid > -1) {
				this.positionCombo.setValueByID(role.postid);
				this.positionCombo.fireEvent(FR.Events.AFTEREDIT);
			}						
		} else {
			this.orgnizeRolePane.hide();
			this.customRolePane.show();
			this.nameText.setValue(role.text);			
		}
		if (role.id == null) {
			this.report_backup = [];
			this.widget_backup = [];
			this.module_backup = [];
			this.process_backup = [];
			return;
		}
		var auth = FS.Trans.getRoleAuth(role);
		if (auth.users) {
			this.usersPane.popUsers(auth.users);
		}
		this.reportTree.selecteByID(auth.reports);
		this.report_backup = auth.reports ? auth.reports.slice(0) : [];
		this.processList.selecteByID(auth.process);
		this.process_backup = auth.process ? auth.process.slice(0) : [];
		this.moduleTree.selecteByID(auth.modules);
		this.module_backup = auth.modules ? auth.modules.slice(0) : [];
	},
	
	refreshProcessList : function() {
		this.processList.fireEvent(FS.Events.RELOADDATA);
		var role = this.roleList.getSelectedData();
		if (role && role.id != null) {
			var auth = FS.Trans.getRoleAuth(role);
			this.processList.selecteByID(auth.process);
			this.process_backup = auth.process ? auth.process.slice(0) : [];
		}
	},
	
	refreshReportTree : function() {
		this.reportTree.fireEvent(FS.Events.RELOADDATA);
		var role = this.roleList.getSelectedData();
		if (role && role.id != null) {
			var auth = FS.Trans.getRoleAuth(role);
			this.reportTree.selecteByID(auth.reports);
			this.report_backup = auth.reports ? auth.reports.slice(0) : [];
		}
	},
		
	clearState : function() {
		this.orgnizeCombo.setValue('');
		this.positionCombo.setValue('');
		this.nameText.setValue('');
		this.usersPane.clearContent();
		this.reportTree.clearChoose();
		this.report_backup = null;
		this.processList.clearChoose();
		this.process_backup = null;
		this.moduleTree.clearChoose();
		this.module_backup = null;
	},
	
	getRole : function() {
		var role = this.roleList.getSelectedData();
		if (this.orgnizeRolePane.is(':visible')) {
			role.departmentid = this.orgnizeCombo.getSelectedID();
			role.postid = this.positionCombo.getSelectedID();
		}
		return role;
	},
	
	autoRoleSave : function () {
		var self = this;
		setTimeout(function(){
			self.toolbarPane.text('.');
			self.saveRole();
			self.toolbarPane.text('.');
		}, 25);
	},
	
	saveRole : function() {
		var reports = this.reportTree.getSelectedID(true), process = this.processList.getSelectedID(), modules = this.moduleTree.getSelectedID(), users;
		var reportPrivilege = {}, processPrivilege = {}, modulePrivilege = {};
		var self = this;
		if (this.report_backup) {
			reportPrivilege = this.checkPrivilegeArray(this.report_backup, reports, true);
		}
		if (this.process_backup) {
			processPrivilege = this.checkPrivilegeArray(this.process_backup, process, false);
		}
		if (this.module_backup) {
			modulePrivilege = this.checkPrivilegeArray(this.module_backup, modules, false);
		}
		if (this.usersPane && this.usersPane.element.is(':visible')) {
			users = this.usersPane.getUsersID();
		}
		var role = this.getRole();
		var id = FS.Trans.saveRole(role, reportPrivilege, processPrivilege, modulePrivilege, users);
		if (id == "false") {
			FR.Msg.toast("жԸòԼְλȨã벻Ҫظãβ豣");
		} else if (id  > -1){
			this.roleList.getSelectedData().id = id;
		}
	},
	
	checkPrivilegeArray : function(baseArray, newArray, isEntry) {
		var result = {};
		if (baseArray && newArray) {
			var add = result.add = [];
			var remove = result.remove = [];
			var comparatorFn = isEntry ? this.comparateEntryString : this.comparateNumber;
			baseArray = baseArray.sort(comparatorFn);
			newArray = newArray.sort(comparatorFn);
			
			var bi = 0, ni = 0;
			var cr = 0;
			for (; bi < baseArray.length && ni < newArray.length; bi++) {
				cr = comparatorFn.call(this, baseArray[bi], newArray[ni]);
				
				while (cr > 0) {
					add[add.length] = newArray[ni];
					ni ++;
					if (ni >= newArray.length) break;
					cr = comparatorFn.call(this, baseArray[bi], newArray[ni]);
				}
				
				if (ni >= newArray.length) break;
					
				if (cr == 0) {
					ni ++;
				} else {
					remove[remove.length] = baseArray[bi];
				}
			}
			
			for (; bi < baseArray.length; bi++) {
				remove[remove.length] = baseArray[bi];
			}
			for (; ni < newArray.length; ni++) {
				add[add.length] = newArray[ni];
			}
			// һ
			if ((add.length - remove.length) != (newArray.length - baseArray.length)) {
				throw "checkPrivilegeArray error!";
			}
		}
		
		return result;
	},
	
	comparateNumber : function(a, b) {
		return a - b;
	},
	
	comparateEntryString : function(a, b) {
		if (a.length < 2 || b.length < 2) {
			throw "wrong entry id!";
		}
		
		var a_sub = a.substring(0,1);
		var b_sub = b.substring(0,1);
		var r = a_sub - b_sub;
		if (r == 0) {
			a_sub = a.substring(1);
			b_sub = b.substring(1);
			return a_sub - b_sub;
		} else {
			return r;
		}
	}
});

/*b:ѡԶɫû*/
FS.usersWidget = FS.extend(FS.Widget, {
	init : function(config) {
		this.element = $('<div/>').attr('id', 'fs_auth_role_userdialog');
		this.checkbox = [];
		this.generateDepartmentUser();
	},
	
	refresh : function() {
		this.element.empty();
		this.checkbox = [];
		this.generateDepartmentUser();
	},
	
	generateDepartmentUser : function() {
		var departments = FS.Trans.getDepartUsers();
		for (var i = 0, len = departments.length; i < len; i++) {
			var depart = departments[i];
			$('<span/>').addClass('fs_auth_role_depart').text(depart.departmentname + ":").appendTo(this.element);
			var employee = depart.users, leng = employee.length;
			var tbody = $('<tbody/>').appendTo($('<table/>').appendTo(this.element))
			for(var n = 0, nen = Math.ceil(leng/6); n < nen; n++) {
				var tr = $('<tr/>').appendTo(tbody);
				for (var j = 0; j < 6; j++) {
					var b = 6*n + j;
					if (b >= leng) {
						continue;
					}
					var em = employee[b];
					var cb = new FR.CheckBox({
						text : em.text,
						renderEl : $('<div/>').appendTo($('<td/>').appendTo(tr))
					});
					cb.element.data('user', em);
					this.checkbox.push(cb);
				}
			}
		}
	},
	
	popUsers : function(users) {
		if (users == null) {
			users = [];
		}
		users = $.map(users, function(user) {
			return user.id;
		});
		for (var i = 0, len = this.checkbox.length; i < len; i++) {
			var checkbox = this.checkbox[i];
			if (users.indexOf(checkbox.element.data('user').id) > -1) {
				checkbox.setSelected(true);
			} else {
				checkbox.setSelected(false);
			}
		}	
	},
	
	getUsers : function() {
		var users = [];
		for (var i = 0, len = this.checkbox.length; i < len; i++) {
			var checkbox = this.checkbox[i];
			if (checkbox.isSelected()) {
				users.push(checkbox.element.data('user'));
			}
		}
		return users;
	},
	
	reBuild : function() {
		
	}
});