/*user's info && change password*/
FS.Privacy = FS.extend(FS.Widget, {
		init : function(config) {
			this.element = $('<div/>').attr('id', 'fs_user');
			this.userToolbar();
			this.userPaneInit();
			this.submitPaneInit();
			this.element.append(this.toolbar).append(this.userPane).append(this.submitPane);
			this.resize(config);
		},
		
		/*bؼlater*/
		userToolbar : function() {
			this.toolbar = $('<div/>').attr('id', 'fs_usertoolbar');
			var self = this;
			this.userb = new FS.ToolbarButton({
				text : 'Ϣ',
				height : 22,
				handler : function() {
					self.pwb.element.removeClass('fs_button_selected');
					if (self.pwPane) {
						self.pwPane.hide();
					}
					self.userPane.show();								
				}
			});
			this.userb.element.attr('id', 'fs_userinfo').addClass('fs_button_selected');
			this.pwb = new FS.ToolbarButton({
				text : '޸',
				height : 22,
				handler : function() {
					if (!self.pwPane) {
						self.pwPaneInit();
					}
					self.userb.element.removeClass('fs_button_selected');
					self.userPane.hide();
					self.pwPane.show();			
				}
			});
			this.pwb.element.attr('id', 'fsuserpw');
			this.toolbar.append(this.userb.element).append(this.pwb.element);
		},
		
		userPaneInit : function() {
			this.userPane = $('<div/>').attr('id', 'fs_userinfopane');
			var lr = "fs_userinfol2r";
			this.userAccount = new FS.TextEditor({
				width : 100,
				enable : false,
				disabled : true
			});
			this.userName = new FS.TextEditor({
				width : 100,
				disabled : true
			});
			this.sexGroup = new FR.RadioGroup({
				width : 100,
				height : 20,
				adaptive : true,
				items : [{text:'', value: 'true'}, {text:'Ů', value: 'false'}]
			});
			this.birth = new FR.DateTimeEditor();
			this.mobile = new FS.TextEditor({
				width : 120,
				regex : /^[\d]{11}$/,
				errorMsg : 'ȷֻ'
			});
			this.email = new FS.TextEditor({
				width : 180,
				regex : /^\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$/,
				errorMsg : 'ȷַ'
			});
			var self = this;
			setTimeout(function() {
				var user = self.user = FS.Trans.getSelfInfor();
				self.userAccount.setValue(user.username);
				self.userName.setValue(user.realname);
				self.sexGroup.setValue(user.male);
				if (user.birthday) {
					self.birth.setValue(user.birthday);
				}			
				self.mobile.setValue(user.mobile);
				self.email.setValue(user.email);
			}, 25);
			this.userTable = $('<table id="fs_userinfotalbe" cellSpacing="4"/>').append($('<tbody/>')
				.append($('<tr/>').append($('<td/>').addClass(lr).text('˺ţ')).append($('<td/>').append(this.userAccount.element)))
				.append($('<tr/>').append($('<td/>').addClass(lr).text('')).append($('<td/>').append(this.userName.element)))
				.append($('<tr/>').append($('<td/>').addClass(lr).text('Ա')).append($('<td/>').append(this.sexGroup.element)))
				.append($('<tr/>').append($('<td/>').addClass(lr).text('գ')).append($('<td/>').append(this.birth.element)))
				.append($('<tr/>').append($('<td/>').addClass(lr).text('ֻ')).append($('<td/>').append(this.mobile.element)))
				.append($('<tr/>').append($('<td/>').addClass(lr).text('䣺')).append($('<td/>').append(this.email.element))));
			this.userTable.appendTo(this.userPane);
		},
		
		pwPaneInit : function() {
			this.pwPane = $('<div/>').attr('id', 'fs_userpwpane');
			this.oldpw = new FS.TextEditor({
				width : 100,
				passwordText : true
			});
			this.newpw = new FS.TextEditor({
				width : 100,
				passwordText : true
			});
			this.conpw = new FS.TextEditor({
				width : 100,
				passwordText : true
			});
			var lr = "fs_userinfol2r";
			this.pwTable =  $('<table id="fs_userpwtalbe" cellSpacing="4"/>').append($('<tbody/>').append($('<tr/>').append($('<td/>').addClass(lr).text('룺')).append($('<td/>').append(this.oldpw.element)))
				.append($('<tr/>').append($('<td/>').addClass(lr).text('룺')).append($('<td/>').append(this.newpw.element)))
				.append($('<tr/>').append($('<td/>').addClass(lr).text('ȷ룺')).append($('<td/>').append(this.conpw.element))));

			this.pwPane.append(this.pwTable).insertBefore(this.submitPane);
		},
		
		popInfo : function() {
			var info = FS.Trans.getUserInfo();
			this.userAccount.setValue(info.account);
			this.userName.setValue(info.name);
			this.sexGroup.setValue(info.sex);
			this.birth.setValue(info.birth);
			this.mobile.setValue(info.mobile);
			this.email.setValue(info.email);
		},
		
		updateInfo : function() {
			$.extend(this.user, {
				male : this.sexGroup.getValue(),
				birthday : this.birth.getValue(),
				mobile : this.mobile.getValue(),
				email : this.email.getValue()
			});
			var info = "Ϣύɹ!";
			if (FS.Trans.saveSelfInfor(this.user) != "true") {
				info = "Ϣʧ!";
			} 
			FR.Msg.toast(info);
		},
		
		updatepw : function() {
			if (this.newpw.getValue() != this.conpw.getValue()) {
					FR.Msg.toast("벻һ");
					return false;
			}
			FR.Msg.toast(FS.Trans.changePW(this.oldpw.getValue(), this.newpw.getValue()) == 'true' ? "޸ĳɹ!" : "޸ʧܣȷȷ!");
		},
		
		submitPaneInit : function() {
			this.submitPane = $('<div/>').attr('id', 'fs_userinfosubmit');
			var self = this;
			this.submitButton = new FS.Button({
				text : 'ύ޸',
				handler : function() {
					if (self.userPane.is(':visible')) {
						self.updateInfo();
					} else {
						self.updatepw();
					}
				}
			});
			this.submitPane.append(this.submitButton.element);
		},
		
			resize : function(rec) {
				if (!rec) {
		 			var p = this.element.parent();
		 			rec = {
		 				width : p.width(),
		 				height : p.height()
		 			};
		 		}
				this.element.width(rec.width).height(rec.height);
				this.toolbar.width(rec.width).height(52);
				this.userPane.width(rec.width).height(rec.height - 82);
				if (this.pwPane) {
					this.pwPane.width(rec.width).height(rec.height - 82);
				}
				this.submitPane.width(rec.width).height(30);
			}
	});