
FS.SYSTEMEXAMINE = {
	examoption : {},
	init : function () {
		var examOptionDiv = $('div#fs_examine_option');
		var examButtonDiv = $('div#fs_examine_button');
		var items = [{text : 'ü', value : 'server'},{text : 'FineServer', value : 'fs'},
			{text : 'Ʒע', value : 'register'},{text : 'ȫԼ', value : 'globalattr'}];
		examoption = new FR.CheckBoxGroup({
			renderEl : examOptionDiv,
			columnsInRow : 1,
			width : 200,
			height : 150,
			items : items
		});
		this.exambutton = new FR.Button({
			renderEl : examButtonDiv,
			width : 150,
			height : 30,
			text : '',
			listeners : [{eventName : 'click', action : this.examAction}]
		});
	},
	_createResultTableHead : function() {
		var thead = $('<thead/>').addClass('fs_examine_resultTableHead');
		var args = [{text:'', width:'5%'}, 
			{text:'', width:'60%'},
			{text:'޸Ľ', width:'35%'}];
		$.each(args, function(idx, item) {
			thead.append($('<th/>').attr('nowrap', 'nowrap').css('width', item.width).text(item.text));
		});
		return thead;
	},
	_createResultTableTr : function(args) {
		var tr = $('<tr/>');
		$.each(args, function(idx, item) {
			tr.append($('<td/>').text(item));
		});
		return tr;
	},
	_embellishBackground : function(table) {
		var trs = table.children('tbody').children('tr');
		$.each(trs, function(i) {
			if (i%2 == 0) {
				$(trs[i]).addClass('fs_examine_resultTable_tre');
			} else {
				$(trs[i]).addClass('fs_examine_resultTable_tro');
			}
		});
	},
	examAction : function() {
		var examInfoDiv = $('div#fs_examine_result');
		var examOptions = examoption.getValue();
		if(examOptions == '') {
			return
		} else {
			var self = FS.SYSTEMEXAMINE;
			var examingDiv = $('<div/>').addClass('fs_exmaing').append('ڼfs...');
			examInfoDiv.html('');
			examInfoDiv.append(examingDiv);
			self.exambutton.setValue('ڼ');
			self.exambutton.disable();
			$.ajax({
				url : FR.servletURL,
				data : {
					op : 'fs_sysexam',
					examOptions : examOptions
				},
				complete : function(res, status) {
					var errorNum = 1;
					examInfoDiv.html('');
					var resultTable = $('<table/>').addClass('fs_examine_resultTable').appendTo(examInfoDiv);
					resultTable.append(self._createResultTableHead());
					resultTable.append($('<tbody/>'));
					var tbody = $('tbody', resultTable);
					var result = FR.jsonDecode(res.responseText);
					if(result.memory === false) {
						tbody.append(self._createResultTableTr([errorNum, 'ڴ̫С', 'ǰõڴΪ'
							+result.currentMemory+'M鲻ӦС'+result.idealMemory + 'M']));
						errorNum ++;
					} 
					if(result.registerInfo === false) {
						tbody.append(self._createResultTableTr([errorNum, 'עʧ', '뾡עᣬδע汾ͬʱɷģIPΪ5ϢƲοƽ̨עϢ']));
						errorNum ++;
					} else if(result.registerInfo == true) {
						tbody.append(self._createResultTableTr([errorNum, 'עɹ', '']));
						errorNum ++;
					}
					if(result.unExistFiles) {
						$.each(result.unExistFiles, function(idx, item) {
							tbody.append(self._createResultTableTr([errorNum, 
								result.workDirectory + '/' + item+'', 'ģܱɾƶλãɾFSӦģ޸λ']));
							errorNum ++;
						});
					}
					if(result.globalAttr) {
						$.each(result.globalAttr, function(idx, item) {
							if(item !== false) {
								tbody.append(self._createResultTableTr([errorNum, idx + "ȱȫʽ\"" + item + '\"', "Ϊ\""+item+"\"ȫʽ޸ģ壬ȡʹøȫʽ"]));
								errorNum ++;
							} else {
								//wei : ˵ģxmlд󣬱startElement,endElementƥ
								tbody.append(self._createResultTableTr([errorNum, idx + "д", "ȡģʱģļ𻵣XMLļʼ/ǩƥ"]));
								errorNum ++;
							}
						});
					}
					self._embellishBackground(resultTable);
					self.exambutton.setValue('¼');
					self.exambutton.enable();
				}
			});
		}
	}
};