/*
 * b:tabpane before 6.5.3,layout,north&center
 * show content item{title:'my desktop', contentEl:$dom||src:*.cpt(iframe), closable : false}
 * cssл
 * */
$.fn.tabs = {};
$.fn.tabs.isSeed = 0;
FS.TabPane = FR.extend(FR.Widget, {
	_defaultConfig : function() {
		 return $.extend(FR.Button.superclass._defaultConfig.apply(), {
         	width : "100%",
			height : "100%",
			border : true,
			activeTab:0,
			fit : true,
			scrollIncrement: 80,
		    scrollDuration: 200,
			items : []
        });
	},
	
    _init : function() {
         FS.TabPane.superclass._init.apply(this, arguments);
         this._createContent();  
         this._registerMoveButtonEvents();
         this.confirmSize();
    },
    
    _createContent : function() {
    	var opts = this.options;
    	this.element.addClass("fr-tabs-container");

		this.ml = $('<div class="fr-tabs-scroller-left"/>');
		this.mr = $('<div class="fr-tabs-scroller-right"/>');
		this.mx = $('<div class="fr-tabs-close"/>');
		this.tabs = $('<ul class="fr-tabs"></ul>');
		this.header = $('<div class="fr-tabs-header"/>').append($('<div class="fr-tabs-wrap"/>').append(this.tabs)).append(this.ml).append(this.mr).append(this.mx);
		this.panel = $('<div class="fr-tabs-panels"/>').css('overflow', 'hidden');
		var items = opts.items;
		this.element.append(this.header).append(this.panel);
		for (var i = 0, len = items.length; i < len; i ++) {
			this._addTab(items[i]);
		}
    },
    
    
    _registerMoveButtonEvents : function() {
    	var opts = this.options;
        var el = this.element;
        $.each([this.ml, this.mr, this.mx], function(i, item) {
        	item.hover(
        		function(){
        			if(this.disabled)
        				$(this).removeClass('fr-tabs-scroller-over');
        			else
        				$(this).addClass('fr-tabs-scroller-over');
        		},
				function(){
					$(this).removeClass('fr-tabs-scroller-over');
				}
			);
			item.bind("mousedown", function(e){
				if(this.disabled)
					$(this).removeClass('fr-tabs-scroller-click');
				else
					$(this).addClass('fr-tabs-scroller-click');
			});
			item.bind("mouseup", function(e){
				$(this).removeClass('fr-tabs-scroller-click');
			});
        });
    	var header = this.header;
		var panels = this.panel;
		var tabs = this.tabs;
		if (opts.border == true){
			header.removeClass('fr-tabs-header-noborder');
			panels.removeClass('fr-tabs-panels-noborder');
		} else {
			header.addClass('fr-tabs-header-noborder');
			panels.addClass('fr-tabs-panels-noborder');
		}
		var self = this;

		this.mr.unbind('click.fr-tabs').bind('click.fr-tabs', function() {
			var couldremove = self._getMaxScrollWidth();
			if (couldremove > 0) {
				var wrap = $('.fr-tabs-wrap', header);
				var width = self.getScollValueRight();
				var hs = wrap.scrollLeft();
				$('.fr-tabs-wrap', header).animate({scrollLeft: couldremove > width ? hs + width : hs + couldremove}, opts.scrollDuration);
			}
			self.checkButtonState();
		});
		
		this.ml.unbind('click.fr-tabs').bind('click.fr-tabs', function() {
			var wrap = $('.fr-tabs-wrap', header);
			var hs = wrap.scrollLeft();
			if (hs > 0) {
				var width = self.getScollValueLeft();
				wrap.animate({scrollLeft : hs > width ? hs - width : 0}, opts.scrollDuration);
			}
			self.checkButtonState();
		});
		
		this.mx.unbind('click.fr-tabs').bind('click.fr-tabs', function(){
			if (!this.disabled){ 
			var confirm = window.confirm("ȷرҳ棿");
			if (confirm) {
				var elem = $('li[title][title != ҵҳ]');
				var nextActiveTab = $('li[title = ҵҳ]');
				//daniel:Ҫƶɼλ
				var wrap = $('.fr-tabs-wrap', header);
				var hs = wrap.scrollLeft();
				if (hs > 0) {
					//ʹ0Ϊƶʱ䣬200msӳ󣬸ͻأĸоΪȽϴ
					wrap.animate({scrollLeft : 0}, 0);
				}
				elem.remove();
				nextActiveTab.triggerHandler('click');
				//رеĲҪȴ
				self.checkButtonEnabled();
			}
			}
		});
    },
    
    checkButtonEnabled : function (){
    	var self = this;
		//mr
		var couldremove = self._getMaxScrollWidth();
		if (couldremove > 0) {
			self.mr[0].disabled = false;
			self.mr.removeClass("fr-tabs-scroller-enabled");
		} else {
			self.mr[0].disabled = true;
			self.mr.addClass("fr-tabs-scroller-enabled");
		}
		//ml
		var wrap = $('.fr-tabs-wrap', self.header);
		var hs = wrap.scrollLeft();
		if(hs > 0) {
			self.ml[0].disabled = false;
			self.ml.removeClass("fr-tabs-scroller-enabled");
		} else {
			self.ml[0].disabled = true;
			self.ml.addClass("fr-tabs-scroller-enabled");
		}
		//mx
		var elem = $('li[title][title != ҵҳ]');
		if (elem.size() > 0) {
			self.mx[0].disabled = false;
			self.mx.removeClass("fr-tabs-scroller-enabled");
		} else {
			self.mx[0].disabled = true;
			self.mx.addClass("fr-tabs-scroller-enabled");
		}
    },
    
    //daniel:ȴƶȷť״̬
    checkButtonState : function(){
    	var self = this;
    	setTimeout(function(){
    		self.checkButtonEnabled();
    	}			//ʱһ㣬ȴtabƶ		
		, self.options.scrollDuration + 50);
    },
    //tabһtab
    getScollValueRight : function() {
    	var elem = $('li[title = ҵҳ]');
    	var wrap = $('.fr-tabs-wrap', this.header);
    	//ҵҳұߵľ
    	var divWidth = wrap.width() - elem.offset().left + 207;
    	//еıǩҳ
    	var elems = $('li[title]');
    	var length = 0 ;
    	var value;
    	//danielһtabĿ
    	$.each(elems, function(i, tag){
    		//4Ǳǩ֮ļ
    		length += $(tag).width() + 4;
    		if (length > divWidth){
    			value = $(tag).width() - length + divWidth;
    			if(i > 0 && value < $(tag).width())
    				value += $(elems[i-1]).width() + 4;
    			return false;
    		}
    	});
    	return value ? wrap.width() - value : 0;
    },
    
    //tabһtab
    getScollValueLeft : function() {
    	var elem = $('li[title = ҵҳ]');
    	//ҵҳ߿ͷľ
    	var divWidth = 0 - elem.offset().left + 207;;
    	var elems = $('li[title]');
    	var length = 0 ;
    	var value;
    	//ҪһtabĿ
    	$.each(elems, function(i, tag){
    		length += $(tag).width() + 4;
    		if (length > divWidth){
    			value = length - divWidth;
    			if (i < elems.length - 1 && value < $(tag).width())
    				value += $(elems[i+1]).width() + 4;
    			return false;
    		} 
    	});
    	var wrap = $('.fr-tabs-wrap', this.header);
    	return value ? wrap.width() - value : 0;
    },
    
    addItem : function(item) {
    	this.clearActiveState();
    	var elem = $('li > span.fr-tabs-inner', this.header);
		for (var i = 0, len = elem.length; i < len; i++) {
			if ($(elem[i]).text() == item.title) {
				$(elem[i]).parent().triggerHandler('click');
				var iframe = $('iframe', this.activePane);
				//bug 5963 ʱȸĳÿε
				if (iframe &&item.src && item.src != null && iframe.length ) {//&& iframe.attr('src') != item.src) {
					iframe.attr('src', item.src);
				} else if (!iframe.context && item.src) {
					//ɾ
					this.activePane.children().detach();
					this.activePane.append($('<iframe/>').css({height : '100%', width : '100%'}).attr({frameborder : 0, src : item.src}));
				} else if (item.contentEl){
					this.activePane.children().detach();
					this.activePane.append(item.contentEl);
				}
				return;
			}
		}
    	this._addTab(item);
    	this.checkButtonState();
    },
    
    _addTab : function(item) {
    	var header = this.header;
		var tabs = this.tabs;
		var tab = this.activeTab = $('<li/>').attr({tIndex: $.fn.tabs.isSeed, title : item.title, unselectable : 'on'}).css('display', 'inline').mouseover(
				function() {
					if ($(this).hasClass('fr-tabs-selected')) {
						return;
					}
					$(this).addClass('fr-tabs-hover');
				}
			).mouseout(
				function() {
					if ($(this).hasClass('fr-tabs-selected')) {
						return;
					}
					$(this).removeClass('fr-tabs-hover');
				}
			);
		tab.addClass('fr-tabs-selected');
		
		var tab_a = $('<span class="fr-tabs-inner"/>').text(item.title);
		/*b:ie font line-heightӰ*/
		if ($.browser.msie && /[\u4e00-\u9fa5]+/.test(item.title)) {			
			tab_a.css({position : 'relative', top : -1});	
		}
		tab.append($('<span>&nbsp;</span>').addClass('fr_tab_lc')).append(tab_a).append($('<span>&nbsp;</span>').addClass('fr_tab_rc')).appendTo(tabs);
		if (item.closable !== false) {
			tab_a.addClass('fr-tabs-closable');
			var close = $('<a href="javascript:void(0)" class="fr-tabs-close"/>');
			close.click(function() {
				self.closeTab($($(this).parent()[0]).attr("title"));
			});
			tab_a.after(close);
		}
		if (item.icon) {
			tab_a.addClass('fr-tabs-with-icon');
			tab_a.prepend($('<span/>').addClass('fr-tabs-icon').addClass(item.icon));
		}		
		var wrap = $('.fr-tabs-wrap', header);
		var sw = this._getMaxScrollWidth();
		if (sw > 0) {			
			wrap.animate({scrollLeft: '+=' + sw}, this.options.scrollDuration);
		}
		
		var content = this.activePane = $("<div/>").attr("id", "fr-tabs-panel" + $.fn.tabs.isSeed++ ).css({width : '100%', height : '100%'});
		//b:fsרãitems϶಻ӦֱӼ
		if (item.contentEl) {
			content.append(item.contentEl);
		} else if (item.src) {
			content.append($('<iframe/>').css({height : '100%', width : '100%'}).attr({frameborder : 0, src : item.src}));
		} 
		
		content.appendTo(this.panel);
		//b:պ϶Ӱ
		var self = this;
		tab.click(function(e) {
			self.clearActiveState();
			self.activeTab = tab.addClass('fr-tabs-selected');
			tab.removeClass('fr-tabs-hover');
			//b:animate later
			self.activePane = content.show();
			self.activePaneResize();
			var taboffset = tab.offset().left;
			var opts = self.options;
			//200ʾδ
			if(taboffset > 200){
				var wrap = $('.fr-tabs-wrap', header);
				//tabĻߵľȥбĿ200+ԼĿȼȥмdivĿ
				var width = taboffset - 200 + tab.width() - wrap.width();
				if (width > 0) {
					var couldremove = self._getMaxScrollWidth();
					if (couldremove > 0) {
						var hs = wrap.scrollLeft();
						$('.fr-tabs-wrap', header).animate({scrollLeft: couldremove > width ? hs + width : hs + couldremove}, opts.scrollDuration);
						self.checkButtonState();
					}
				}
			} else {
				var wrap = $('.fr-tabs-wrap', header);
				var hs = wrap.scrollLeft();
				if (hs > 0) {
					//ʼλõֵȥĻߵľ
					var width = 207 - taboffset;
					wrap.animate({scrollLeft : hs > width ? hs - width : 0}, opts.scrollDuration);
					self.checkButtonState();
				}
			}
		});
    },
    
    clearActiveState : function() {
    	if (this.activeTab) {
    		this.activeTab.removeClass('fr-tabs-selected');
    		this.activePane.hide();
    	}
    }, 
    
    _getTabLeftPosition : function(tab) {
    	var w = 0;
		var b = true;
		$('>div.fr-tabs-header ul.fr-tabs li', this.element).each(function(){
			if (this == tab) {
				b = false;
			}
			if (b == true) {
				w += $(this).outerWidth(true) + 4;
			}
		});
		return w;
    },
    
    _getMaxScrollWidth : function() {
    	var header = this.header;
		var tabsWidth = 0;	// all tabs width
		$('ul.fr-tabs li', header).each(function(){
			tabsWidth += $(this).outerWidth() + 4;
		});
		var wrap = $('.fr-tabs-wrap', header);		
		return tabsWidth - wrap.width() - wrap.scrollLeft();
    },
    
    //b:ie6 ie7 consider boxmodel later if useful
    confirmSize : function(rec) {
    	var el = this.element;
    	var opts = this.options;
    	if (rec) {
    		this.options.width = rec.width;
    		this.options.height = rec.height;
    	} else if (rec == null && opts.fit == true){
			var p = el.parent();
			this.options.width = p.width();
			this.options.height = p.height();
		}
		
		el.width(opts.width);
		el.height(opts.height);
		this.header.width(opts.width);
		var header = this.header, wrap = $('.fr-tabs-wrap', header);
		wrap.width(header.width() - 65);
		var ph = parseInt(el.height() - header.outerHeight());
		this.panel.height(ph);
		this.panel.width(opts.width);	
    },
    
	activePaneResize : function(rec) {
		if (this.activePane) {
			this.activePane.height(this.panel.height());
			this.activePane.width(this.panel.width());
			var child = $(this.activePane.children()[0]);
			if (!rec) {
				rec = {
					width : this.panel.width(),
					height : this.panel.height() + 31
				};
			}
			if (child.data('container')) {
				child.data('container').resize({
					width : rec.width,
					height : rec.height - 31
				});
			}
		}
	},
    
    resize : function(rec) {
    	this.confirmSize(rec);
		this.activePaneResize(rec);
    },
    
    closeActiveTab : function() {
    	this.closeTab(this.activeTab.attr('title'));
    },
    
    closeTab : function(title) {
    	var opts = this.options;
    	var elem = $('li[title][title = "'+title+'"]', this.header);
    	//daniel containsʶŵ...޷ر
		//var elem = $('li:has(span:contains("' + title + '"))', this.header);
		if (!elem[0])  {
			return;
		}
		var nextActiveTab = elem.next()[0] ?  elem.next() : elem.prev();
		$('#fr-tabs-panel' + elem.attr('tIndex'), this.pane).detach();
		//ΪʲôҪ-1ȷĽ?
		var width = elem.width() - 1; 
		elem.remove();
		//ƶƵȷλ
		var wrap = $('.fr-tabs-wrap', this.header);
		var hs = wrap.scrollLeft();
		if (hs > 0) {
			wrap.animate({scrollLeft : hs > width ? hs - width : 0}, opts.scrollDuration);
			this.checkButtonState();
		}
		
		nextActiveTab.triggerHandler('click');
    }
});