$(function() {	
	var south = $('#fs_bpage'), center = $('#fs_cpage');
 	var border = new FR.BorderLayout({
 		items : [{
 				region : 'center',
 				el : center
 		}, {
 				region : 'south',
 				el : south
 		}],
 		renderEl : $('body')
 	});
	
	var user = new FR.TextEditor({
		renderEl : $('#username'),
		width : 160,
		height : 20,
		allowBlank : false,
		errorMsg : 'ûΪ'
	}), pw = new FR.TextEditor({
		renderEl : $('#password'),
		passwordText : true,
		width : 160,
		height : 20,
		allowBlank : false,
		errorMsg : '벻Ϊ'
	}), saveinfo = new FR.CheckBox({
		renderEl : $('#saveinfo'),
		text : 'ֵ¼״̬'
	}), submitButton = new FR.Button({
		renderEl : $('#submit'),
		text : '¼',
		width : 72,
		height : 24,
		hotkeys : 'enter',
		handler : signIN
	});
	initInfo();
	$(window).resize(function() {
		resize();
	});
	resize();
	
	
	function resize() {
		border.doLayout();
	}
	
	function initInfo() {
		if (document.cookie == null) {
			return;
		}
		var username = FR.cjkDecode(FR.CookieInfor.getCookieByName('fsusername')), 
			password = FR.CookieInfor.getCookieByName('fspassword'), 
			remember = FR.CookieInfor.getCookieByName('fsremember');
		if (username != null && username != '') {
			user.setValue(username);
		}
		if (password != null && password != '') {
			pw.setValue(password);
		}
		if (remember != null && remember != '') {
			saveinfo.setSelected(remember);
		}
	}
		
	function signIN() {
		if (!user.isValidate()) {
			$('#fs_errormsg').text(user.errorMsg);
			return;
		}
		if (!pw.isValidate()) {
			$('#fs_errormsg').text(pw.errorMsg);
			return;			
		}
		$.ajax({
			url : FR.servletURL + '?op=fs_load&cmd=login',
			data : genUser(),
			type : 'POST',
			async : false,
			error : function() {
				FR.Msg.toast("Error!");
			},
			complete : function(res, status) {
				if (res.responseText == "") {
					$('#fs_errormsg').text("֤ʧܣ");
					return;
				}
				var signResult = FR.jsonDecode(res.responseText);				
				if (signResult.fail) {
					userError();
				} else if (signResult.url) {
					window.location.href = signResult.url;
				}
			}
		});
	}
	
	//b:Ǽ
	function genUser() {
		return FR.cjkEncodeDO({
			fsusername : user.getValue(),
			fspassword : pw.getValue(),
			fsremember : saveinfo.isSelected()
		});
	}
	
	function userError() {
		$('#fs_errormsg').text('û벻ƥ䣡');
	}
});
