/**
 * ûNavigatorID͸һĬϵĵ
 */
FR.MobileNavigatorId = {
    index : 100001
}

/**
 * @version 6.5.6
 * @date 2011/11/02
 * ʺtablet,߱Զ豸Ǵں״̬Ӧʽ
 * Ϊ
 * ֳɶർԼҲʾ󲿷
 * ¼contentChange, navigateChange
 */
FR.SplitView = FR.extend(FR.Layout, {
    _defaultConfig : function () {
        return $.extend(FR.SplitView.superclass._defaultConfig.apply(), {
            baseCls:"fr-mobile-split-view",
            titleHeight:40,
            left : {width : 300}
        });
    },
    _init : function() {
        FR.SplitView.superclass._init.apply(this, arguments);
        var self = this, o = this.options;
        // ԼеPage
        this.records = {};
        this.toolbarButtons = [];
        o.historyRecords = [];
        this.options.dynamicTB = [];
        this.element.addClass(o.baseCls);
        var $header = $("<div class='fr-mobile-split-header'>");
        this.$toolbar = $header;
        this._initHeaderToolbarBtn();
        this._addLeftDefaultMenuButton($header);
        var $content = $("<div class='fr-mobile-split-content'>");
        this.layout = new FR.BorderLayout({
            renderEl:self.element,
            items : [
                {"region" : "north", el : $header, height: o.titleHeight},
                {"region" : "center", el: $content}
            ]
        });
        var $left = $("<div class='fr-mobile-split-left'>");
        if (o.items) {
            for (var idx = 0, len = o.items.length; idx < len; idx ++) {
                var item = o.items[idx];
                if (!item.id) {
                    item.id = FR.MobileNavigatorId.index ++;
                }
                var nav = FR.createWidget($.extend({}, item, {renderEl : $left}));
                this.records[item.id] = nav;
                if (!item.invisible) {
                    this.currentPage = nav;
                }
            }
        }
        this.$main = $("<div class='fr-mobile-split-main'>");
        this.lowerLayout = new FR.BorderLayout({
            renderEl: $content,
            items : [
                {"region" : "west", el: $left, width : o.left.width},
                {"region" : "center", el: self.$main, _resize : function() {
                    self._doMainResize()
                }}
            ]
        })
    },

    /**
     * תһҳ󣬵ø÷ص֮ǰʹҳ
     */
    goNavigatorBack : function() {
        var o = this.options, self = this;
        var back = o.historyRecords.pop();
        if (FR.isEmptyArray(o.historyRecords)) {
            // ûʷҳʱ,طذť
            this.$backBtn.hide();
        }
        if (back) {
            this.currentPage.setVisible(false);
            back.showWithAnimation("slideright");
            back.once("showAnimationEnd", function() {
                self.currentPage = back;
            })
        }
    },

    /**
     * һµ
     * @param action ΪһJSON {action : {target : "#id", main : false}}
     * targetʶҳIDһʾFR.WidgetJSONmainʾǷFR.SplitViewʾ
     */
    open : function(action) {
        var config = action.target || action;
        if (action.main || action.type) {
            this._openView(config);
            this.fireEvent("contentChange", config);
        } else {
            this._navigate(config);
            this.fireEvent("navigateChange", config);
        }
    },
    /**
     * ̬ӺʵĹť
     * @param config
     */
    setToolbarButton : function(config) {
        this.options.dynamicTB.push(FR.createWidget($.extend({}, config, {renderEl : this.$toolbar})));
    },

    /**
     * ർתһҳķ
     * @param to Ŀҳid,idҪ"#"ͷʶ
     */
    _navigate : function(to) {
        var self = this, o = this.options, from;
        if (this.currentPage) {
            from = this.currentPage;
            o.historyRecords.push(from);
        }
        if (to.startWith("#")) {
            to = to.substring(1);
        }
        this.currentPage = this.records[to];
        from.hideWidthAnimation();
        from.once("hideAnimationEnd", function() {
            self.currentPage.setVisible(true);
            self.$backBtn.show();
        })
    },
    /**
     * ұʾݲչʾӦ
     * @param config һFR.Widget͵json
     */
    _openView : function(config) {
        this.$main.empty();
        this._destroyDynamicTB();
        this.mainLayout = FR.createWidget($.extend({}, config, {renderEl : this.$main}));
        if ($.isFunction(this.mainLayout.doLayout)) {
            this.mainLayout.doLayout();
        }
        this.doLayout();
    },
    _doMainResize : function() {
        if (this.mainLayout && this.mainLayout.doLayout) {
            this.mainLayout.doLayout();
        }
    },
    /**
     * λĲťһ(ʾ)Լذť
     */
    _addLeftDefaultMenuButton : function() {
        var self = this;
        this.$leftToolbarBtnContainer = $("<span class='fr-mobile-split-toolbar-left'>").appendTo(this.$toolbar);
        this.$backBtn = $("<a class='fr-mobile-toolbar-btn'>").css("display", "none").text(FR.i18n.Back).appendTo(this.$leftToolbarBtnContainer)
            .click(function() {
                self.goNavigatorBack();
            });
        $("<a class='fr-mobile-toolbar-btn'>").text(FR.i18n.Hide)
            .appendTo(this.$leftToolbarBtnContainer)
            .click(function() {
                var $btn = $(this);
                if (self.options.leftHide) {
                    self.options.leftHide = false;
                    $btn.text(FR.i18n.Hide);
                    self.lowerLayout._expandPanel({region:"west", customExpand:true});
                } else {
                    self.options.leftHide = true;
                    $btn.text(FR.i18n.Show);
                    self.lowerLayout._collapsePanel({region:"west", customExpand:true});
                }
            });
    },
    /**
     * еĶ̬ӵİť
     */
    _destroyDynamicTB : function() {
        for (var idx = 0; idx < this.options.dynamicTB.length; idx ++) {
            this.options.dynamicTB[idx].destroy();
        }
        this.options.dynamicTB = [];
    },
    /**
     * ʼղءʷťԼҲ ûлûҳť
     */
    _initHeaderToolbarBtn : function() {
        var o = this.options, self = this;
        if (o.toolbar) {
            for (var idx = 0, len = o.toolbar.length; idx < len; idx ++) {
                this.toolbarButtons.push(FR.createWidget($.extend({}, o.toolbar[idx], {renderEl : this.$toolbar})));
            }
        }
    },
    doLayout: function() {
        FR.SplitView.superclass.doLayout.apply(this, arguments);
        if (this.layout) {
            this.layout.doLayout();
        }
        if (this.lowerLayout) {
            this.lowerLayout.doLayout();
        }
        if (this.mainLayout && this.mainLayout.doLayout) {
            this.mainLayout.doLayout();
        }
    }
})

/**
 * ΪһĶ,FR.SplitViewĵ͵Ķ
 */
FR.MobileNavigator = FR.extend(FR.Widget, {
    _defaultConfig : function () {
        return $.extend(FR.MobileNavigator.superclass._defaultConfig.apply(), {
            baseCls:"fr-mobile-page"
        });
    },
    _init : function() {
        FR.MobileNavigator.superclass._init.apply(this, arguments);
        var o = this.options;
        this.$pageContainer = $("<div class='" + o.baseCls + "'>")
            .appendTo(this.element)
            .attr("id", o.id);
        this.scroller = new iScroll(this.element[0], {

        }, this.$pageContainer[0]);
        this._initContent();
        this.setVisible(!o.invisible);
    },
    /**
     * ͨش˷ӵthis.$pageContainer
     */
    _initContent : function() {
    },
    /**
     * setVisible
     */
    setVisible : function(arg) {
        if (!this.$pageContainer) {
            return;
        }
        if (arg === true) {
            this.options.invisible = false;
            this.$pageContainer.show();
            this.scroller.refresh();
        } else if (arg === false) {
            this.options.invisible = true;
            this.$pageContainer.hide();
        }
    },
    /**
     * ָĶЧʾҳ
     * @param animation 嶯class
     */
    showWithAnimation : function(animation) {
        var ait = animation ? animation : "slideleft";
        var self = this;
        var navHandler = function() {
            self.$pageContainer.removeClass(ait + " in")
                .unbind("webkitAnimationEnd")
                .unbind("webkitTransitionEnd");
            self.fireEvent("showAnimationEnd");
        }
        this.$pageContainer.show().addClass(ait + " in")
            .bind("webkitAnimationEnd", navHandler)
            .bind("webkitTransitionEnd", navHandler);
        this.scroller.refresh();
    },
    /**
     * ָĶЧظҳ
     * @param animation 嶯class
     */
    hideWidthAnimation : function(animation) {
        var ait = animation ? animation : "slideleft";
        var self = this;
        var navHandler = function() {
            self.$pageContainer.hide().removeClass(ait + " out")
                .unbind("webkitAnimationEnd")
                .unbind("webkitTransitionEnd");
            self.fireEvent("hideAnimationEnd");
        }
        this.$pageContainer.addClass(ait + " out")
            .bind("webkitAnimationEnd", navHandler)
            .bind("webkitTransitionEnd", navHandler);
    }
})

/**
 * ƶƽ̨бؼ
 */
FR.MobileListView = FR.extend(FR.MobileNavigator, {
    _defaultConfig : function() {
        return $.extend(FR.MobileListView.superclass._defaultConfig.apply(), {

        })
    },
    _init : function() {
        FR.MobileListView.superclass._init.apply(this, arguments);
        var self = this, o = this.options;
        if (o.items) {
            for (var i = 0, len = o.items.length; i < len; i ++) {
                this._addListCell($.extend({}, o.items[i], {topView : o.topView, listView : this}));
            }
        }
    },
    _initContent : function($container) {
        FR.MobileListView.superclass._initContent.apply(this, arguments);
        this.$ul = $("<ul class='fr-mobile-list-view'>").appendTo(this.$pageContainer);
    },
    /**
     *бʾԪ
     * @param item JSON󣬸ʽμFR.MobileListCell
     */
    _addListCell : function(item) {
        item.renderEl = $("<li class='fr-mobile-list-cell'>")
            .appendTo(this.$ul);
        new FR.MobileListCell(item);
    }
})
$.shortcut("listview", FR.MobileListView);

/**
 * FR.ListViewʾԪأöӦõ
 */
FR.MobileListCell = FR.extend(FR.Widget, {
    _defaultConfig : function() {
        return $.extend(FR.MobileListCell.superclass._defaultConfig.apply(), {
            text : "",
            description : "",
            // ָʾԪԪصĬϲʾñ
            counter : null,
            smallIcon : "",
            // Ĭڵߴ
            action : {target : "", main : false}
        })
    },
    _init : function() {
        FR.MobileListCell.superclass._init.apply(this, arguments);
        var self = this, o = this.options;
        this.element.bind("touchstart",
            function() {
                $(this).addClass("fr-mobile-list-cell-active");
            }).bind("touchmove",
            function() {
                $(this).removeClass("fr-mobile-list-cell-active");
            }).bind("touchend", function() {
                $(this).removeClass("fr-mobile-list-cell-active");
            })
        var $aContainer = $("<a class='fr-mobile-list-cell-content" + (o.counter != null ? " arrow" : "") + "'>").appendTo(this.element)
            .bind("click",
            function() {
                self.fireEvent(FR.Events.CLICK);
            });
        $("<h3 class='fr-mobile-list-cell-title'>" + o.text + "</h3>").appendTo($aContainer);
        if (o.description) {
            $("<p class='fr-mobile-list-cell-des'>" + o.description + "</p>").appendTo($aContainer);
        }
        if (o.counter !== null) {
            $("<span class='fr-mobile-list-counter'>" + o.counter + "</span>").appendTo($aContainer);
        }
        if (o.smallIcon) {
            $("<span class='fr-mobile-list-small-icon " + o.smallIcon + "'>")
                .bind("click",
                function(e) {
                    self.fireEvent("iconClick");
                    e.stopPropagation();
                }).appendTo($aContainer);
        }
    },
    /**
     * бԪصͼ
     * @param newIcon ͼclass
     */
    setSmallIcon : function(newIcon) {
        var oldSmallIcon = this.options.smallIcon;
        this.options.smallIcon = newIcon;
        $(".fr-mobile-list-small-icon", this.element)
            .removeClass(oldSmallIcon)
            .addClass(newIcon);
    },
    /**
     * ȡǰͼclass
     */
    getSmallIcon : function() {
        return this.options.smallIcon;
    }
})

FR.MobileToolbarButton = FR.extend(FR.Widget, {
    _defaultConfig : function() {
        return $.extend(FR.MobileToolbarButton.superclass._defaultConfig.apply(), {
            location : "left",
            iconCls : "",
            text : ""
        })
    },
    _init : function() {
        FR.MobileToolbarButton.superclass._init.apply(this, arguments);
        var o = this.options, self = this;
        this.$btn = $("<span class='fr-mobile-toolbar-icon-btn'>")
            .appendTo(this.element)
            .bind("click", function(e) {
                self.fireEvent(FR.Events.CLICK, e);
            });
        if (o.iconCls) {
            this.$btn.addClass(o.iconCls);
        }
        if (o.el) {
            this.$btn.append($(o.el));
        }
        this.setText(o.text);
        if (typeof o.location == "string") {
            this.$btn.css({float:o.location});
        } else {
            this.$btn.css($.extend({}, o.location, {position : "absolute"}));
        }
        this.fireEvent(FR.Events.INIT);
    },
    /**
     * ðťʾ
     * @param text
     */
    setText : function(text) {
        var o = this.options;
        o.text = (text == null || text == "undefined") ? "" : text;
        if (o.el) {
            o.el.text(o.text);
        } else {
            this.$btn.text(o.text);
        }
    },
    /**
     * ȡťʾ
     */
    getText : function() {
        return this.options.text;
    },
    /**
     * ٰť
     */
    destroy: function() {
        this.$btn.remove();
    }
})
$.shortcut("mtbtn", FR.MobileToolbarButton);

/**
 *йرհťԼ˵ͼƬʾؼ
 */
FR.MobilePhoto = FR.extend(FR.Widget, {
    _defaultConfig : function () {
        return $.extend(FR.MobilePhoto.superclass._defaultConfig.apply(), {
            // ͼƬĵַ
            imageSrc : "${servletURL}?op=resource&resource=/com/fr/fs/web/mobile/images/smalltpl.png",
            // ͼƬ
            description:""
        });
    },
    _init : function() {
        FR.MobilePhoto.superclass._init.apply(this, arguments);
        var o = this.options;
        var self = this;
        var $wrap = this.element.addClass("fr-mobile-photo-wrap");
        var $closeTag = $("<p class='fr-mobile-photo-close'>").appendTo($wrap);
        var $closeHref = $("<a title='Close' class='fr-mobile-photo-closebg'>")
            .bind("click",
            function() {
                self.fireEvent("close");
            }).appendTo($closeTag);
        var $photoContent = $("<div class='fr-mobile-photo-content'>").appendTo($wrap);
        var $target = $("<a style='cursor:pointer'>")
            .bind("click", function() {
                self.fireEvent("click");
            })
            .appendTo($photoContent);
        this.imageWrap = $("<img/>").attr("src", o.imageSrc)
            .css({display:"block"})
            .appendTo($target);
        var $descroption = $("<div class='fr-mobile-photo-discription'>").text(o.description).appendTo($wrap);
    },
    doResize : function(give) {
        FR.MobilePhoto.superclass.doResize.call(this, give);
        if (give) {
            this.imageWrap.attr("width", give.width).attr("height", give.height);
        }
    }
});
$.shortcut("photo", FR.MobilePhoto);

/**
 * ؼֳ֣һǵײĵ֣мչʾݽ϶ʱԶҳ
 */
FR.MobileCarousel = FR.extend(FR.Layout, {
    _defaultConfig : function () {
        return $.extend(FR.MobileCarousel.superclass._defaultConfig.apply(), {
            activeIndex:0,
            columns:3,
            rows:2,
            totalPage:1,
            items : []
        });

    },
    _init:function() {
        FR.MobileCarousel.superclass._init.apply(this, arguments);
        var o = this.options;
        // 
        this.$carouselWrapper = $("<div class='fr-mobile-carousel-wrapper'>");
        // 
        this.$scrollContent = $("<div class='fr-mobile-carousel-scroller'>").appendTo(this.$carouselWrapper);
        // 
        this.$nav = $("<div class='fr-mobile-carousel-nav'>");
        this.contentLayout = new FR.BorderLayout({
            items : [
                {region: "center", el : this.$carouselWrapper},
                {region: "south", el:this.$nav, height:40}
            ],
            renderEl:this.element
        });
        this.build();
    },
    // ̬ȡղصĿչֳ
    build : function() {
        var o = this.options, self = this;
        // ֮ǰ
        this.$nav.empty();
        this.$scrollContent.empty();
        // ڿؼвʾloadingͼ
        FR.showLoadingMark(this.element);
        $.ajax({
            url:o.url,
            complete:function(res, status) {
                FR.hideLoadingMark();
                self._buildItems(FR.jsonDecode(res.responseText));
            }
        })
    },
    /**
     * ݻȡJSON飬Carouselhtmlҳ
     * @param items
     */
    _buildItems : function(items) {
        var o = this.options, self = this;
        o.totalPage = Math.floor((items.length - 1) / (o.columns * o.rows)) + 1;
        var $navDiv = $("<div class='fr-mobile-carousel-content'>").appendTo(this.$nav);
        var $navUL = $("<ul class='fr-mobile-carousel-indicator'>").appendTo($navDiv);
        for (var count = 0; count < o.totalPage; count ++) {
            var $li = $("<li>").text(count + 1).appendTo($navUL);
            if (count == o.activeIndex) {
                $li.addClass("on");
            }
        }
        o.altercolumns = o.columns * o.totalPage;
        this._calculateScrollContentSize();
        this.scroll = new iScroll(this.$carouselWrapper[0], {
            snap: true,
            momentum: false,
            hScrollbar: false,
            onScrollEnd: function () {
                o.activeIndex = this.currPageX;
                $("li.on", $navUL).removeClass("on");
                $("li:nth-child(" + (this.currPageX + 1) + ")", $navUL).addClass("on");
            }
        });
        var elArr = [];
        for (var i = 0, len = items.length; i < len; i ++) {
            var gr = Math.floor(i / o.columns) % 2;
            var gc = i - Math.floor((i / o.columns)) - gr * 2 - Math.floor(i / (o.columns * o.rows));
            var pItem = items[i];
            pItem.parent = this;
            elArr.push({column: gc, row: gr, el:pItem});
        }
        this.grid = new FR.GridLayout({
            columns:o.altercolumns,
            rows:o.rows,
            items : elArr,
            // hgapҪleftGap,ҪΪڶҳʱÿһҳߵļ϶һ
            hgap:40,
            vgap:60,
            leftGap:20,
            rightGap:20,
            topGap:20,
            bottomGap:60,
            renderEl: this.$scrollContent
        });
        this.doLayout();
    },
    /**
     *ĴСҪĻʾСԼҳȷ
     */
    _calculateScrollContentSize : function() {
        var o = this.options;
        this.$scrollContent.css({width:this.$carouselWrapper.width() * o.totalPage, height:this.$carouselWrapper.height()});
    },
    destroy : function() {
        this.element.empty();
    },
    doResize : function(give) {
        FR.MobileCarousel.superclass.doResize.call(this, give);
    },
    doLayout : function() {
        FR.MobileCarousel.superclass.doLayout.apply(this, arguments);
        this.contentLayout.doLayout();
        this._calculateScrollContentSize();
        var o = this.options;
        if (this.grid) {
            this.grid.doLayout();
        }
        if (this.scroll) {
            this.scroll.refresh();
            // ԭĵҳ봦
            for (var t = 0; t < Math.min(o.activeIndex, o.totalPage - 1); t ++) {
                this.scroll.scrollToPage('next', 0);
            }
        }
    }

});
$.shortcut("carousel", FR.MobileCarousel);

/**
 * Żؼ
 */
FR.MobilePortal = FR.extend(FR.Widget, {
    _defaultConfig : function () {
        return $.extend(FR.MobilePortal.superclass._defaultConfig.apply(), {
            baseCls:"fr-fs-mobile-portal",
            // Ĭǹ
            width:400,
            height:250
        });
    },
    _init : function() {
        FR.MobilePortal.superclass._init.apply(this, arguments);
        var o = this.options;
        this.$portal = $("<div class='fr-fs-mobile-portal'>")
            .appendTo(this.element)
            .css({width:o.width, height:o.height});
        this.$header = $("<div class='fr-fs-mobile-portal-header'>").appendTo(this.$portal);
        var $type = $("<div class='fr-fs-mobile-portal-select'>").appendTo(this.$header);
        this.$headerSpacer = $("<div class='fr-fs-mobile-portal-spacer'>").appendTo(this.$header);
        // ڻṩɾӹܣťʱȥ
        //var $remove = $("<div class='fr-fs-mobile-portal-remove'>").appendTo(this.$header);
        this.$wrapper = $("<div class='fr-fs-mobile-portal-wrapper'>").appendTo(this.$portal);
        if (o.data) {
            this.addContent(o.data.type);
        }
    },

    addContent : function(pType) {
        switch (pType) {
            case 0:
                this._addBulletin();
                break;
            case 1:
                this._addCalendar();
                break;
            case 2:
                this._addReport();
        }
    },

    _addBulletin : function() {
        var self = this;
        this.setTitle(FR.i18n.Bulletin);
        $.ajax({
            key : 'bulletin',
            returnString : true,
            url : FR.servletURL + "?op=fs_manager&cmd=getbulletin",
            complete:function(res, status) {
                $("<div>").text(res.responseText).appendTo(self.$wrapper);
            }
        })
    },

    _addCalendar : function() {
        // do nothing
        this.setTitle(FR.i18n.Calendar);
        var $calendar = $("<div class='fr-fs-portal-calendar'>").appendTo(this.$wrapper);
        $calendar.html("ǰʱΪ:" + new Date());
    },

    _addReport : function() {
        this.setTitle(this.options.data.chartlet.text);
        var src = FR.servletURL + "?op=fs_main&cmd=portal_report&id=" + this.options.data.chartlet.id;
        var $iframe = $("<iframe>").attr({frameborder:0, width: "100%", height:"100%", src: src}).appendTo(this.$wrapper);
    },

    setTitle : function(text) {
        this.$headerSpacer.text(text);
    },

    doResize : function(give) {
        FR.MobilePortal.superclass.doResize.call(this, give);
        if (give) {
            this.$portal.css({width:give.width, height:give.height});
        }
    }
});
$.shortcut("mobileportal", FR.MobilePortal);

FR.MobilePortalContainer = FR.extend(FR.Layout, {
    _defaultConfig : function () {
        return $.extend(FR.MobilePortalContainer.superclass._defaultConfig.apply(), {
            baseCls:"fr-fs-mobile-portal-container",
            url:""
        });
    },
    _init : function() {
        FR.MobilePortalContainer.superclass._init.apply(this, arguments);
        this._loadMobilePortals();
    },

    _loadMobilePortals : function() {
        FR.showLoadingMark(this.element);
        var self = this;
        $.ajax({
            url:this.options.url,
            complete : function(res, status) {
                FR.hideLoadingMark();
                self.options.items = FR.jsonDecode(res.responseText);
                self._buildContent();
                self.doLayout();
            }
        })
    },
    _buildContent : function() {
        this.element.empty();
        var items = this.options.items;
        if (!items) {
            return;
        }
        // richer:Ŀǰֻ4ؼ̶
        var gridConfig = {
            type:"grid",
            columns:2,
            rows:2,
            hgap:20,
            vgap:50,
            leftGap:20,
            rightGap:20,
            topGap:0,
            bottomGap:60,
            items : [],
            renderEl:this.element
        };
        var len = items.length;
        for (var i = 0; i < 4; i ++) {
            var elConfig = {el:{type: "mobileportal"}, column: Math.floor(i % 2), row:Math.floor(i / 2)};
            if (i < len) {
                elConfig.el.data = items[i];
            }
            gridConfig.items.push(elConfig);
        }
        this.grid = FR.createWidget(gridConfig);
        this.grid.doLayout();
    },
    doLayout : function() {
        FR.MobilePortalContainer.superclass.doLayout.apply(this, arguments);
        this._buildContent();
    }
});
$.shortcut("portalcontainter", FR.MobilePortalContainer);


